# „předmětové“ a adverbiální vedlejší věty
from rules import Rules
from .cz_clauses import indicative_clauses_initial, verbals_with_constituents


# TODO: chce to iword
subordinators = Rules(
    # t=M nakolik
    # '(SUBORDINATOR) → (word=že|aby|co|kdo|kdy|dokud|kde|kam|odkud|nakolik|'
    #                        'když|proč|kolik|kudy)',
    # „aby“ je zajímavější, protože se skládá ze spojky a slovesa (značka k=Y)
    # TODO: nezobrazuju jiné atributy než morfologické, vrátit zpátky ;-)
    '(SUBORDINATOR type=place) → (lemma=dokud|kde|kam|odkud|kudy)',
    '(SUBORDINATOR) → (lemma=že|co|kdo|kdy||nakolik|když|'
                      'proč|kolik|aby|kdyby|jak|zda)',
    # co podstatného / jak důležitý
    '(SUBORDINATOR) → (word=co|jak) (k=2)',
    '(SUBORDINATOR) → (k=7) (word=co|čeho|čemu|čem|čím)',
    # „Je nám docela jedno, který den to uděláme“ ukazuje, že ta vedlejší věta
    # může mít formu snad libovolné otázky…
    '(SUBORDINATOR) → (PP)',
)

# podřadicí výraz se může odsunout z iniciální do preiniciální pozice, proto
# jsou pravidla v dvojicích

# Podal jí nůž, (z jehož čepele) stále odkapávala krev.

# TODO: cože? je to pořád ta samá vedlejší věta, jen v té _hlavní_ je v různých
# pozicích – ty příklady jsou mimo, patří spíš do cz_clauses
# že přijde pozdě, to nám opomněl předem sdělit
# že přijde pozdě, nám opomněl předem sdělit
object_clauses_preinitial = indicative_clauses_initial.insert_into_all(
    '(CLITICS)', position=1).insert_into_all(
    '(SUBORDINATOR type)', before=True, update_left='(DEP_CLAUSE type)')

object_clauses_initial = verbals_with_constituents.insert_into_all(
    '(SUBORDINATOR type) (CONSTITUENTS)', before=True, update_left='(DEP_CLAUSE type)')
object_clauses_initial = object_clauses_initial.insert_into_all(
    '(CLITICS)', position=1)

subordinate_clauses = object_clauses_preinitial + object_clauses_initial
subordinate_clauses = subordinate_clauses.insert_into_all(
    '(INTER)', inside=True).insert_into_all(
    '(OPT_COMMA)', before=True, after=True)
# vypadá to, že to není úplně jednoduchý
#   *že utekli jsme z hodiny
#   že jsme utekli z hodiny (iniciální, postiniciální)
#   že ten kluk se ulil z hodiny (preiniciální, iniciální, postiniciální)
#   že se ulil z hodiny (iniciální, postiniciální)

# TODO: tohle je jen zkratka, udělat to pořádně
subordinate_clauses += Rules(
    '(ANOTHER_DEP_CLAUSE) → (DEP_CLAUSE)',
    '(ANOTHER_DEP_CLAUSE) → (CLAUSE)',
)

# že/co jsem (to) nevěděl
# že maminka se (asi) ztratila

# Kdo	kdo	k3yRnSc1,k3yInSc1,k3yQnSc1hP
# kdo to nevěděl
# komu jsem to nedal
# na koho naléhal

# věty:
# samostatné   oznamovací                             CLAUSE (MATRIX_CLAUSE)
#              tázací (s tázacím … na začátku)        INTERROGATIVE_CLAUSE
#              přací (s nějakou částicí na začátku)   ?
# nesamostatné přívlastkové                           ATTR_CLAUSE
#              podmětné/předmětné                     ?
#              adverbiální (časové, místní, způsobové atd.)

rules = subordinators + subordinate_clauses
